﻿$(function(){	
	window.App="Preference";
	layout();
	loadData();

});


function layout(){
	window.Layout = $('body').layout({ 
			center__paneSelector:"#main" 
		,	north__paneSelector:"#top" 
		,	north__size:48
		,	north__spacing_open:0
		,	resizable:false
	}); 
	$('.ui-layout-pane').css({overflow:'hidden'});
}

function bindEvent(){
	$(".program_toolbar a").click(function(){		
		$("#Setup").show();
		$("#All").hide();
	});
	
	$("#All li").click(function(){
		var t=$("label",this).attr("msgid");
		if(t&&t!=='')window.win.setTitle("<label domain='l10n' msgid='" + t+ "'>"+$.l10n.__(t)+"</label>");
		else window.win.setTitle("<label>"+$("label",this).text()+"</label>");
		window.win.resize(640,$(this).attr("_height")-0);
	});	
	$("#SHOWALL").click(function(){	showAll();	});
	$("li").addClass('enabled');
}


function loadData(){
	$.ajax({
		url:window.top.urlpath+'Configurations/System/preferences.xml'
		,dataType:'xml'
		,success:parseData
		,error:function(){
		}
	});
}


function parseData(data){
	$('items',data).each(function(){
		var id=$(this).attr('id');
		var $ul=$('#'+id+' ul');
		$('item',this).each(function(){
			var i=$('icon',this).text();
			var h=$('height',this).text();
			var n=$('name',this).text();
			var l=$(this).attr('l10n');
			var L=$(this).attr('lang');
			if(L){
				L=L.split(',');
				if($.inArray(window.top.Lang,L)===-1)return;
			}
			$ul.append('<li class="t'+i+'" _height="'+h+'"><a href="'+n+'.html" target="Setup"><img src="../../Library/blank.gif"/><br/><label ' + (l==='no'?'':'domain="l10n"  msgid="Preference_main_text_'+n+'"')   +'>'+(l==='no'?n:'')+'</label></a></li>');
		});
	});
	//if(window.top.Lang!=='zh-tw')$('li.t23').hide();
	loadLang();
	bindEvent();
}

function show(name){
	var $a=$('#All a[href="'+name+'.html"]');
	$a.parent().click();
	$a.click();
	window.open(window.top.urlpath+'Applications/Preference/'+name+'.html','Setup');
}

function showAll(){
	$("#Setup").hide();
	$("#All").show();
	$("#Setup").attr('src','about:blank');
	var win=window.top.curWin;
	var t="System_application_Preference";
	window.win.setTitle("<label domain='l10n' msgid='"+t+"'>"+window.top.$.l10n.__(t)+"</label>");
	window.win.resize(640,500);
}

window.top.Preference.show=show;