﻿$(function(){
	window.App="SocialNetwork";	
	loadLang();	
	layout();
	bindEvent();
	init();
});

function layout(){
	$('body').layout({ 
			center__paneSelector:"#main"
		,	north__paneSelector:"#top"  
		,	north__size:80
		,	north__spacing_open:0
		,	west__paneSelector:"#left"  
		,	west__size:200
		,	west__spacing_open:0
		,	south__paneSelector:"#bottom"  
		,	south__size:60
		,	south__spacing_open:0
		//,	center__minWidth:400
		,	contentSelector:".data"
	}); 
}

function bindEvent(){
	$('#login').unbind('click').click(function() {
		window.top.flickrtoken=null; 
		var url='http://myisharing.com/flickr.html?api='+new Date().getTime()+'&origin='+window.location.href;
		document.getElementById('isharing').contentWindow.location.replace(url);
	});
	$('#logout').unbind().click(toLogout);	
	$('#CREATE').unbind().click(toCreateSet);
	$('#UPLOAD').unbind().click(showUpload);
	$('#REFRESH').unbind().click(init);	
	$('#tree').delegate('a','click',function(){
		$('#tree a.selected').removeClass('selected');
		$(this).addClass('selected');
		if($(this).hasClass('unknown')){
			loadContent();
		}else{
			showContent(this.resp);
		}
	});
	$('#data').delegate('div','click',function(){
		$('#data div.selected').removeClass('selected');
		$(this).addClass('selected');		
	})
	try{
		var win=window.win.mask;
		var thiswin=window; 
		window.top.$(win)
			.droppable('destroy')
			.droppable({
			accept:'#main li.image'
			,drop: function(event, ui) {
					if(!window.top.flickrauth)return;
					var curWin=window.win;
					var $C;
					if(curWin.id=='App_MyNAS_Win_main')$C=window.top.MyNAS.mainWin.content.$C;
					if(curWin.id=='App_AlbumMaker_Win_main')$C=window.top.AlbumMaker.mainWin.content.$C; 
					var items=(ui.draggable.hasClass('image'))?[ui.draggable[0]]:null;
					if(ui.draggable.hasClass('selected')){
						var lis=window.top.$('li.selected.image',$C); 
						if(lis.length>0){
							items=null;
							items=lis; 
						}
					}
					if (!items)return;
					var itempaths=[]; 
					for(var i=0;i<items.length;i++){
						itempaths.push(items[i].getAttribute('webview').replace('?webview','?').replace('session='+window.top.SessionID,'').replace('login='+window.top.user,''));
					}; 
					thiswin.toUpload(itempaths);
			}
			,hoverClass: 'drophover'
		});
	}catch(e){}
}

function init(){
	$('#logout,#REFRESH,#CREATE,#UPLOAD').hide();
	if(!window.top.flickrtoken)window.top.flickrtoken={};
	if(window.top.flickrtoken&&window.top.flickrtoken.access_token){
		$('#login').hide();
		$('#logout,#REFRESH,#CREATE,#UPLOAD').show();
		$('#username').html(window.top.flickrtoken.username);
		loadAlbum();
		return;
	}
	if(window.top.flickrtoken&&window.top.flickrtoken.oauth_token){
		getAccessToken();
		return;
	}
	var oauth_token=getRequest('oauth_token');
	var oauth_verifier=getRequest('oauth_verifier');
	if(oauth_token&&oauth_verifier){
		window.opener.top.flickrtoken.oauth_token=oauth_token;
		window.opener.top.flickrtoken.oauth_verifier=oauth_verifier;
		window.opener.init();
		window.close();
		return;
	}
	var api_key=getRequest('api_key');
	var api_sig=getRequest('api_sig');
	if(api_key&&api_sig){
		window.top.flickrtoken.api_key=api_key;
		window.top.flickrtoken.api_sig=api_sig;
		getOauthToken();
		return;
	}
	$('#logout,#REFRESH,#CREATE,#UPLOAD').hide();
	$('#login').show().click();
}

function toLogout(){
	//window.open('http://www.flikr.com/','_blank');
	$('#login').show();
	$('#logout,#REFRESH,#CREATE,#UPLOAD').hide();
	$('#username').html('');
	$('#userphoto').attr('src','icons/user.gif');
	window.top.flickrauth=null;
	$('#tree,#data').empty();
}


function getOauthToken(){
	FR({
		url:'/oauth/request_token'
		,data:{
			oauth_callback:'http%3A%2F%2Fmyisharing.com%2Fflickr.html'+encodeURIComponent('?origin='+window.location.href.replace(window.location.search,''))
		}
		,success:function(text){
			var r=text.split('&');
			var data={};
			for(var i=0,l=r.length;i<l;i++){
				var ri=r[i].split('=');
				data[ri[0]]=ri[1];
			}
			if(data.oauth_callback_confirmed==='true'){
				window.top.flickrtoken.oauth_token=data.oauth_token;
				window.top.flickrtoken.oauth_token_secret=data.oauth_token_secret;
				var url='https://www.flickr.com/services/oauth/authorize?perms=write&oauth_token='+data.oauth_token;
				window.open(url,'_flickr','width=1024,height=600,toolbar=0,menubar=0');
			}
		}
	});
}

function getAccessToken(){
	FR({
		url:'/oauth/access_token'
		,data:{
			oauth_verifier:window.top.flickrtoken.oauth_verifier
		}
		,success:function(text){
			var r=text.split('&');
			var data={};
			for(var i=0,l=r.length;i<l;i++){
				var ri=r[i].split('=');
				data[ri[0]]=ri[1];
			}
			window.top.flickrtoken.access_token=data.oauth_token;
			window.top.flickrtoken.access_token_secret=data.oauth_token_secret;
			window.top.flickrtoken.fullname=decodeURIComponent(data.fullname);
			window.top.flickrtoken.username=data.username;
			window.top.flickrtoken.user_nsid=data.user_nsid;
			window.parent.init();
		}
	});
}	



function loadAlbum(){
	FR({
	   data:{
			method:'flickr.photosets.getList'
			,jsoncallback:'showSets'
		}
	});
}


function showSets(resp){
	if(isError(resp)) return;
	var $a=$('#tree a.selected');
	var id=$a[0]?$a[0].id:null;
	if($('#tree').html()===''){
		$('#tree').html('<ul class="normallist album"><li><a id="noset" class="unknown">'+$.l10n.__('Photostream')+'</a></li></ul>');
		$('#tree a#noset')[0].data={id:'noset'};
	}else{
		$('#tree a#noset').parent().siblings().remove();
	}
	var data=resp.photosets.photoset;	
	for(var i=0,l=data.length;i<l;i++){
		addSet(data[i],true);
	}
	if(id)$a=$('#'+id);
	$($a[0]||'#noset').click();
}



function addSet(resp,list){
	if(isError(resp)) return;
	var $ul=$('#tree ul');
	var album=resp.photoset||resp;
	var li = document.createElement('li');
	var a = document.createElement('a');
	a.id=album.id;
	a.resp=resp;
	a.innerHTML = window.newalbumname||album.title._content;
	a.className='unknown';
	//a.href = album.url;
	$(li).append(a).appendTo($ul);
	if(!list)$(a).click();
	window.newalbumname=null;
}




function toCreateSet(){
	if(!window.top.flickrtoken)return;
	var $p=$('#data div.selected');
	if(!$p[0]){alert('Choose one item first!');return;}
	var name=prompt('','');
	if(!name||name==='')return;
	window.newalbumname=name;
	FR({
		data:{
			method:'flickr.photosets.create'
			,title: name
			,primary_photo_id: $p[0].data.id
			,jsoncallback:'addSet'
		}
	});
}


function loadContent(){
	var id=$("#tree a.selected")[0].id;
	if(id==='noset'){
		FR({
			data:{
				method:'flickr.photos.getNotInSet'
				,jsoncallback:'showContent'
			}
		});
		return;
	}
	FR({
		data:{
			method:'flickr.photosets.getPhotos'
			,photoset_id:id
			,jsoncallback:'showContent'
		}
	});
	
}

function showContent(resp){
	if(isError(resp)) return;
	$('#tree a.selected').removeClass('unknown');
	$('#tree a.selected')[0].resp=resp;
	$('#data').html('');
	var ps=(resp.photoset||resp.photos).photo;
	for (var i=0, l=ps.length; i<l; i++) {
		var resp=ps[i];
		var div=document.createElement('div');
		var photo = (resp.photo||resp.source)||resp;
		div.data=photo;
		var url=(resp.source)?resp.source:'http://farm'+photo.farm+'.static.flickr.com/'+photo.server+'/'+photo.id+'_'+photo.secret+'_t.jpg';		
		div.style.cssText='background:#f2f2f2 url('+url+') no-repeat center center;float:left;';
		$('#data').append(div);
    }
	$('#data div:first').click();
}



function showUpload(){
	if($('#tree a.selected').length===0)return;
	window.top.System.opendialog({
		app:window.top.SocialNetwork
		,filter:'image'
		,handler:toUpload
	});
	
}


function toUpload(items){
	var album=$('#tree a.selected')
	if(album.length==0)return;
	var albumid=album[0].id;
	var l=items.length;
	while(l--){
		$("#waiting").show();
		$.ajax({
			url: window.top.remoteDataUrl+"nas/flickr/uploadphoto"
			,cache:false
			,data:{
				hash:window.top.SessionID
				,oauth_consumer_key:window.top.flickrtoken.api_key
				,oauth_token:window.top.flickrtoken.access_token
				,oauth_key:window.top.flickrtoken.api_sig+'&'+window.top.flickrtoken.access_token_secret
				,path:decodeURI(items[l])
			}
			,type: "POST"
			,dataType:"xml"
			,success: function(data){
				$("#waiting").hide();
				if(window.top.checkAPIError(data))return;
				addPotho2Set(data);
			}
			,error:function(data){
				$("#waiting").hide();
				alert ( $.l10n.__("global_alert_getdataerror") );
			}
			//,timeout:20000
		});
	}
}

function addPotho2Set(data,sid){
//<?xml version="1.0" encoding="utf-8"?><nas><photoid>5188830201</photoid></nas>
	$('#waiting').show();
	var sid=$("#tree a.selected")[0].id;
	var pid=$('photoid',data).text();
	if(sid==='noset'){
		//getSizes(pid);
		toRefresh();
	}
	else{
		FR({
			data:{
				method:'flickr.photosets.addPhoto'
				,photoset_id:sid
				,photo_id: pid
				,jsoncallback:'toRefresh'
			}
		});
	}
}

function toRefresh(){
	$('#tree a.selected').addClass('unknown').click();
}



function isError(resp){
	//{"stat":"fail", "code":96, "message":"Invalid signature"}	
	if (resp.stat&&resp.stat==='fail'){
		if(resp.code===98||resp.code===99){
			$('#login').click();
		}else{
			alert (window.top.$.l10n.__("alert_getdataerror")+':'+resp.code+'\n\n'+resp.message);
		}
		return true;
	}
	return false;
}


function FR(o){
	var s=['GET'];
	var url='https://www.flickr.com/services';
	var oauth_token_secret='';
	if(!o.url){
		url='https://api.flickr.com/services/rest';
		o.url='';
		o.dataType='script';
		o.data.format='json';
		o.data.oauth_token=window.top.flickrtoken.access_token;
		oauth_token_secret=window.top.flickrtoken.access_token_secret;
	}else{
		o.dataType='text';
		if(o.url!=='/oauth/request_token'){
			o.data.oauth_token=window.top.flickrtoken.oauth_token;
			oauth_token_secret=window.top.flickrtoken.oauth_token_secret;
		}
	}
	o.data.oauth_nonce=Math.random().toString().replace('0.','');
	o.data.oauth_timestamp=new Date().getTime();
	o.data.oauth_consumer_key=window.top.flickrtoken.api_key;
	o.data.oauth_signature_method='HMAC-SHA1';
	o.data.oauth_version='1.0';
	url=url+o.url;
	s.push(encodeURIComponent(url));
	var names=[];for(var name in o.data){names.push(name);}names.sort();
	var p=[];for(var i=0,l=names.length;i<l;i++){p.push(names[i]+'='+o.data[names[i]]);}
	s.push(encodeURIComponent(p.join('&')));
	s=s.join('&');
	var k=window.top.flickrtoken.api_sig+'&'+oauth_token_secret;
	o.data.oauth_signature= encodeURIComponent(new jsSHA(s, 'TEXT').getHMAC(k,'TEXT','SHA-1','B64') );
	var d=[];for(var i in o.data){d.push(i+'='+o.data[i]);}
	url=url+'?'+d.join('&');
	if(o.dataType!=='script'){
		url='/nas/proxy/get?hash='+window.top.SessionID+'&httpurl='+encodeURIComponent(url);
	}
	$('#waiting').show();
	$.ajax({
		url:url
		,type:'GET'
		,dataType: o.dataType
		,cache:true
		,complete:function(){
			$('#waiting').hide();
		}
		,success:o.success
	});
}