﻿function loadApp(id,fn,path){ 
	if(window.top[id]&&document.getElementById("App_"+id)){
		if(window.top[id].loaded){
			if(window.top[id].active){
				window.top[id].active();
				if(fn){fn();}
				else{window.top[id].main();}
			}else{
				window.top.setTimeout(function(){loadApp(id,fn);},200);
			}
		}else{ 
			try{
				window.top[id].active();
				window.top[id].reload();
			}catch(e){}
		}
		return;
	}
	window.top[id]=new Dean.OS.App({id:id,fn:fn,path:path});
}

Dean.OS.App=function(options){
/*
	参数-----------
	id
	ontop
	
	对象-----------
	container
	app
	win
	tool
	menubar
	menubarmask
	dialog
	menubar.appMenu
	menubar.winMenu
	
	状态---------
	modal
	
	方法--------------
	init()
	active()
	hide()
	hideOther()
	hideMenu()
	showMenu()
	Modoal()
	unModal()
	addToDock()
	quit()
	
	*/

    this.init=function(){
		if(document.getElementById("App_"+options.id)){
		    document.getElementById("App_"+options.id).obj.active();
		    return;
		}
		this.id="App_"+this.options.id; 
		this.path=this.options.path;
		this.menu=this.options.menu;
		this.icon=this.options.icon;
		this.name='<label domain="l10n" msgid="System_application_'+this.options.id+'">'+this.options.id + '</label>';
		this.container=(this.options.ontop)?$("#applicationsOnTop")[0]:$("#applications")[0];
		if(!this.container.maxIndex)this.container.maxIndex=-1;
		this.container.maxIndex++;
		this.app=creatElement(this.container,"div",this.id,"");
		this.app.style.cssText="position:absolute;top:0px;";
		this.app.style.zIndex=this.container.maxIndex;
		this.app.obj=this;
		var mh=$("#menubar").height();
		this.win=creatElement(this.app,"div","","");this.win.style.cssText="position:absolute;top:"+mh+"px;width:100%;height:100%;z-index:0;";	
		this.tool=creatElement(this.app,"div","","");this.tool.style.cssText="position:absolute;top:"+mh+"px;width:100%;height:100%;z-index:1;";
		this.menubar=creatElement(this.app,"div",this.id+"_menubar","application_menubar");this.menubar.style.cssText="position:absolute;height:"+mh+"px;z-index:2;";
		this.menubarmask=creatElement(this.app,"div","","");this.menubarmask.style.cssText="position:absolute;width:1024px;height:"+mh+"px;background:#fff;filter:alpha(opacity=0.1);opacity:0.01;z-index:2;display:none;";
		this.dialog=creatElement(this.app,"div","","");this.dialog.style.cssText="display:none;position:absolute;top:"+mh+"px;width:100%;height:100%;z-index:4;";
		this.systemdialog=$('#dialogs')[0];
		this.win.maxIndex=this.dialog.maxIndex=this.tool.maxIndex=-1;
		
		
		$("#"+this.id+"_menubar >ul").clickMenu();
		$("#"+this.id+"_menubar li li a").click(function(){
			window[$(this).attr("_app")][$(this).attr("_win")]();
		});
		
		this.modal=false;
		if(options.fn)this.onLoad=options.fn;
		this.addToDock();
		window.setLang({app:'System',el:this.app});
		this.active();
		var src=(this.options.path)?this.options.path:window.top.urlpath+"Applications/"+this.options.id;
		$(this.app).append("<div style='display:none;'><iframe style='display:none;' src='"+src+"/init.html'></iframe></div>");
		this.iframe=$('iframe',$(this.app))[0]; 
	}
	
	this.reload=function(){
		this.iframe.contentWindow.location.reload();
	}
	
	this.setMenu=function(menu){
			$(this.menubar).hide().html($("#osmenu")[0].menu);
			this.menubar.appMenu='<li id="'+this.id+'_appMenu">'
				+'<a href="#" style="font-weight:bold;">'+this.name+'</a>'
				+'<ul>'
				//+'<li><a _app="'+this.options.id+'" _win="About">About '+this.options.name+'</a></li>'
				//+'<li><a _app="'+this.options.id+'" _win="Help">'+this.options.name+' Help</a></li>'
				+'<li><a _app="'+this.options.id+'" _win="hide" domain="l10n" msgid="System_menu_hide">Hide</a></li>'
				+'<li><a _app="'+this.options.id+'" _win="hideOther" domain="l10n" msgid="System_menu_hideothers">Hide Others</a></li>'
				//+'<li class="line"></li>'
				//+'<li><a _app="'+this.options.id+'" _win="quit">Exit</a></li>'
				+'</ul>'
				+'</li>';
		
			$(">ul:first",this.menubar).append(this.menubar.appMenu);		

			setLang({app:'System', el:this.menubar}); 
			
			//$("#"+this.id+"_appMenu").after(menu);
			$("#"+this.id+"_menubar >ul").clickMenu()
			//兼容AIR
			$("#"+this.id+"_menubar li li a").click(function(){
				var app=$(this).attr("_app"),win=$(this).attr("_win");
				loadApp(app, function(){window[app][win]();});
			});
			this.menu=menu;
			$(this.menubar).show(); 
		}

	this.setDesktop=function(icons){
		Dean.OS.Desktop.addDesktopIcons(icons,this.id);
	}

	this.active=function (){
		$(this.app).show();
		$(this.menubar).show();	
		if(window.curApp&&window.curApp==this){return;}
		if(window.curApp){window.curApp.deactive();}
		this.container.maxIndex=this.container.maxIndex+1;
		this.app.style.zIndex=this.container.maxIndex;
		window.curApp=this;
		if(this.topWin){this.topWin.active();}
	};

	this.deactive=function(){
		$(this.menubar).hide();
		if(this.topWin){this.topWin.deactive();}
		if(window.curWin)window.curWin=null;
		window.curApp=null;
	}

	this.hide=function (){
		$(this.app).hide();
	};

	this.hideOther=function(){
		var p=window.curApp.container.childNodes
		for(i=0;i<p.length;i++){
			if(p[i].obj!=window.curApp)p[i].style.display="none";
		}
	};
	
	this.hideMenu=function(){
		$(this.menubarmask).show();
	};
	
	this.showMenu=function(){
		$(this.menubarmask).hide();
	};
	
	this.Modal=function(){
	    this.modal=true;
		this.hideMenu();
		$(this.dialog).show();
	};
	
	this.unModal=function(){
		this.modal=false;
		this.showMenu();
		$(this.dialog).hide();
	};
	
	this.addToDock=function(){
	   if($("#dockBody a[_app='+this.options.id+']"))return;
	   $("#dockBody").append('<a _app="'+this.options.id+'" _win="active" _icon="icon.png">'+this.options.name+'</a>');
	   var icon=$("#dockBody a:last")[0];
	   Dean.OS.Desktop.addDockIcon(icon);
	   Dean.OS.Desktop.refreshDock();
	   this.Dock=$("#dockBody a:last");
	}
	
	this.quit=function (){
		$(this.app).remove();
		var wins=$("#windows >div")
		$("#windows a."+this.id).remove();
		if(this.Dock)this.Dock.remove();
		$("#desktopIcons a."+this.id).remove();
		//Dean.OS.Desktop.refreshDock();
		window.curApp=null;
		window[this.options.id]=null;
		
	};
	
	this.options=options;
	this.init();
}


Dean.OS.Win=function(options){
	/*
	参数-----------------------------
	id
	title
	modal:
	type:0-normalwin ,1-dialogwin, 2-Systemmodal 3-toolwin, 4-sidewin
	noborder
	width
	height
	left
	top
	center 居中
	max 最大化
	minWidth
	minHeight
	url:iframe地址
	el:指定元素
	ajaxhtml:ajax地址
	html:内容代码
	resizable
	draggable
	unclosed
	icon: 图标
	
	事件---------------------------------
	onClose

	
	对象------------------------------
	app:
	container
	fromWin
	fromWinObject
	fromSystemWin
	WIN
	shadow
	mask
	win
	nw n ne
	w c e
	sw s se
	close max min
	collpase
	resizer
	content
	
	方法-------------------------------
	init()
	active()
	deactive()
	resize(w,h)
	closeWin()
	hideWin()
	maxWin()
	minWin()
	collapseWin()
	setTitle()
	addToMenu()
	beforeclose()
	
    
    
*/
	this.init=function(){
		this.app=options.app;
		if(this.app)this.app.active();
		if(options.id!=null){
			if(document.getElementById(options.app.id+"_Win_"+options.id)){ 
				document.getElementById(options.app.id+"_Win_"+options.id).obj.active();
				return;
			}			
			this.id=options.app.id+"_Win_"+options.id;
		} 
		this.type=(options.type!=null)?options.type:0;
		switch (this.type){
		    case 0:this.container=this.app.win;this.css="normalwin";break;
		    case 1:this.container=this.app.dialog;this.css="dialogwin";break;
		    case 2:this.container=this.app.systemdialog;this.css="dialogwin";break;
		    case 3:this.container=this.app.tool;this.css="toolwin";break;
		    case 4:this.container=this.app.tool;this.css="sidewin";break;
		    case 5:this.container=this.app.dialog;this.css="noborderwin";break;
		    default:this.container=this.app.win;this.css="normalwin";break;
		}
		
		if(this.options.noborder)this.css="noborderwin";
		if(this.options.classname)this.css += ' '+this.options.classname+' ';
		this.modal=(this.type==1||this.type==2)?true:false;
		if(this.type==1||this.type==2){$(this.container).show();}
		
		this.container.topWin=null;
		this.fromWin=(options.fromWin!=null)?options.fromWin:window;//记录父窗口
		if(options.fromWinObject)this.fromWinObject=options.fromWinObject;
		this.fromSystemWin=(options.fromSystemWin!=null)?options.fromSystemWin:window.curWin;


		this.resizable=(options.resizable!=null)?options.resizable:true;
		this.draggable=(options.draggable!=null)?options.draggable:true;

		this.url=(options.apppath)?this.app.path+'/'+options.url:options.url;
		this.html=options.html;
		this.el=options.el;
		this.ajaxhtml=options.ajaxhtml;

		this.title=(options.title!=null)?options.title:"";

		//位置尺寸
		var w=options.width||600;
		var h=options.height||400;
		var l=options.left||Math.floor(Math.random()*($("body").width()-w));
		var t=options.top||Math.floor(Math.random()*($("body").height()-h));
	
		
		options.center=(options.center!=null)?options.center:false;
		if(options.center){
            		l=($("body").width()-w)/2;
            		t=($("body").height()-h)/2;
        	}
		if(l<0)l=0;
		if(t<0)t=0;
		this.minWidth=options.minWidth||100;
		this.minHeight=options.minHeight||100;
		
		//设置窗体

		this.WIN=creatElement(this.container,"div",this.id,"win "+this.css+" deactive");
		if(!this.container.maxIndex)this.container.maxIndex=-1;
		this.WIN.style.zIndex=this.container.maxIndex;
		//阴影
		this.shadow=creatElement(this.WIN,"div","","shadow");this.shadow.style.cssText="position:absolute;width:100%;height:100%;";
			this.shadow.nw=creatElement(this.shadow,"div","","s-nw");
			this.shadow.n=creatElement(this.shadow,"div","","s-n");
			this.shadow.ne=creatElement(this.shadow,"div","","s-ne");
			this.shadow.w=creatElement(this.shadow,"div","","s-w");
			this.shadow.e=creatElement(this.shadow,"div","","s-e");
			this.shadow.se=creatElement(this.shadow,"div","","s-se");
			this.shadow.s=creatElement(this.shadow,"div","","s-s");
			this.shadow.sw=creatElement(this.shadow,"div","","s-sw");
		this.win=creatElement(this.WIN,"div","","");this.win.style.cssText="position:absolute;top:0px;left:0px;width:100%;height:100%;";
		//边框
		this.nw=creatElement(this.win,"div","","nw");
		this.n=creatElement(this.win,"div","","n");	this.n.innerHTML=this.title;
		this.ne=creatElement(this.win,"div","","ne");
		this.w=creatElement(this.win,"div","","w");
		this.e=creatElement(this.win,"div","","e");
		this.sw=creatElement(this.win,"div","","sw");
		this.s=creatElement(this.win,"div","","s");
		this.se=creatElement(this.win,"div","","se");	
		this.c=creatElement(this.win,"div","","c");
		this.WIN.style.top=t+"px"
		this.WIN.style.left=l+"px";
		this.WIN.style.width=(w+this.e.offsetWidth+this.w.offsetWidth)+"px";
		this.WIN.style.height=(h+this.n.offsetHeight+this.s.offsetHeight)+"px";
		
		//内容
		this.content=this.c;
		
		this.content.style.cssText="position:absolute;left:0px;top:0px;width:100%;height:100%;border:none";
		//loading
		this.loading=creatElement(this.win,"div","","loading");this.loading.style.cssText="position:absolute;left:0px;top:0px;width:100%;height:100%;display:none;z-index:99;";
		this.WIN.loading=this.loading;
		//蒙板
		this.mask=creatElement(this.win,"div","","mask");this.mask.style.cssText="position:absolute;left:0px;top:0px;width:100%;height:100%;background:#000;filter:alpha(opacity=0);opacity:0;z-index:100;";
		this.WIN.mask=this.mask;
		
		//按钮
		this.close=creatElement(this.win,"div","","close");
		this.max=creatElement(this.win,"div","","max");
		this.min=creatElement(this.win,"div","","min");
		this.collapse=creatElement(this.win,"div","","collapse");
		//缩放角
		//this.resizer=creatElement(this.win,"div","","resizer");
		//if(!this.resizable)this.resizer.style.display="none";

		//点击按钮、标题条、蒙板、缩放角激活窗口
		this.close.obj=this.max.obj=this.min.obj=this.collapse.obj=this.WIN.obj=this.n.obj=this.mask.obj=this.loading.obj=this.content.obj=this;
		this.mask.onmousedown=this.n.onmousedown=function(){this.obj.active();};
		this.close.onclick=function(){this.obj.closeWin();};
		if(this.resizable)this.max.onclick=function(){this.obj.maxWin();};
		this.n.max=this.max;
		this.n.ondblclick=function(){$(this.max).click();};
		this.min.onclick=function(){this.obj.minWin();};
		this.collapse.onclick=function(){this.obj.collapseWin();};
		//允许拖拽缩放
		if(this.draggable)$(this.WIN).draggable({ios:true,handle:this.n,iframeFix:true,stop:function(){if(this.offsetTop>$('body').height()-200)this.style.top=px($('body').height()-200);if(this.offsetTop<0)this.style.top="0px";if(this.offsetLeft>$('body').width()-50)this.style.left=px($('body').width()-50);}});//,containment:"#desktopImageMask"
		if(this.draggable&&this.css=="sidewin"){$(this.WIN).draggable({handle:this.w,iframeFix:true,zero:true});$(this.WIN).draggable({handle:this.mask,iframeFix:true,zero:true });}
		if(this.resizable){$(this.WIN).resizable({handles:'se',minHeight: this.minHeight,  minWidth: this.minWidth,  start:function(){$(this.mask).show();} ,stop:function(){$(this.mask).hide();this.obj.resize();}, helper:"ui-dummy" });}		
			
		if(options.maxed)this.maxWin();
			
		
		if(options.onLoad)options.onLoad.apply();
		
		this.resize();
		this.active();	
		
		if(this.url){this.c.innerHTML='<iframe frameborder="0" width="100%" height="100%" allowtransparency="true" src="'+this.url+'"></iframe>';this.content=this.c.firstChild;this.content.contentWindow.win=this;this.content.contentWindow.fromWin=this.fromWin;this.content.contentWindow.fromWinObject=this.fromWinObject;this.content.contentWindow.frameWin=this;};
		if(this.el){this.c.insertBefore(document.getElementById(this.el),null);}
		if(this.html){this.c.innerHTML=this.html;};		
		if(this.ajaxhtml){$(this.content).load(this.ajaxhtml);}

		window.setLang({app:this.app.options.id,el:this.win,path:this.app.path});
		this.addToMenu();
	}
	

	this.active=function(){
	    //$(this.WIN).show();		
		if(!this.icon)this.register();
		if(this.options.unclosed){
			this.WIN.style.display="block";			
		}
		else this.WIN.style.visibility="visible";
		
		if(window.curWin&&window.curWin==this)return;
		if(window.curApp!=this.app&&this.type!=2){this.app.active();}
		if(this.type==1||this.type==2){this.app.Modal();} 
		if(this.app.modal){
			if (this.type==1||this.type==2){
				if(this.container.topWin&&this.container.topWin!=this) return;
			}
			else{
				return;
			}
		}
		if(window.curWin){window.curWin.deactive();}
		this.WIN.className="win "+this.css+" active";
		$(this.mask).hide();
		this.container.maxIndex++;
		this.WIN.style.zIndex=this.container.maxIndex;
		this.app.topWin=this;
		this.container.topWin=this;
		if(this.nxtWin&&this.preWin){this.nxtWin.preWin=this.preWin;this.preWin.nxtWin=this.nxtWin;}
		if(window.curWin&&window.curWin.app==this.app){
			this.preWin=window.curWin;
			window.curWin.nxtWin=this;
		}
		this.nxtWin=null;
		this.resize();
		window.curWin=this;
	}
	
	this.deactive=function(){
		this.WIN.className="win "+this.css+" deactive";
		this.resize();
		$(this.mask).show();
	}

	this.resize=function(w,h){
	    if(w) this.WIN.style.width=px(w+this.e.offsetWidth+this.w.offsetWidth);
		if(h) this.WIN.style.height=px(h+this.n.offsetHeight+this.s.offsetHeight);
		w=this.WIN.offsetWidth;
		h=this.WIN.offsetHeight;
		if(this.nw.offsetWidth==w||this.n.offsetHeight==h||this.ne.offsetWidth==w||this.w.offsetWidth==w||this.e.offsetWidth==w||this.sw.offsetWidth==w||this.s.offsetHeight==h||this.se.offsetWidth==w)return false;
	
		sw=w-(this.shadow.offsetLeft*2);
		sh=h-(this.shadow.offsetTop*2);
		$(this.shadow).width(sw).height(sh);
		this.shadow.n.style.top=this.shadow.ne.style.top=this.shadow.nw.style.top="0px";
		this.shadow.n.style.width=px(sw-this.shadow.ne.offsetWidth-this.shadow.nw.offsetWidth);
		this.shadow.n.style.left=px(this.shadow.nw.offsetWidth);
		this.shadow.ne.style.right=this.shadow.e.style.right=this.shadow.se.style.right="0px";
		this.shadow.e.style.height=px(sh-this.shadow.ne.offsetHeight-this.shadow.se.offsetHeight);
		this.shadow.e.style.top=px(this.shadow.ne.offsetHeight);
		this.shadow.w.style.height=px(sh-this.shadow.nw.offsetHeight-this.shadow.sw.offsetHeight);
		this.shadow.w.style.top=px(this.shadow.nw.offsetHeight);
		this.shadow.s.style.width=px(sw-this.shadow.se.offsetWidth-this.shadow.sw.offsetWidth);
		this.shadow.s.style.bottom=this.shadow.se.style.bottom=this.shadow.sw.style.bottom="0px";
		this.shadow.s.style.right=px(this.shadow.se.offsetWidth);
		
		this.n.style.left=px(this.nw.offsetWidth);
		this.n.style.width=px(w-this.nw.offsetWidth-this.ne.offsetWidth);
		this.ne.style.left=px(this.nw.offsetWidth+this.n.offsetWidth);
		this.w.style.top=px(this.nw.offsetHeight);
		this.w.style.height=px(h-this.nw.offsetHeight-this.sw.offsetHeight);
		this.c.style.left=px(this.w.offsetWidth);
		this.c.style.top=px(this.n.offsetHeight); 
		this.c.style.width=px(w-this.w.offsetWidth-this.e.offsetWidth); 
		this.c.style.height=px(h-this.n.offsetHeight-this.s.offsetHeight);
		
		this.e.style.top=px(this.ne.offsetHeight);
		this.e.style.left=px(this.w.offsetWidth+this.c.offsetWidth);
		this.e.style.height=px(h-this.ne.offsetHeight-this.se.offsetHeight);
		this.sw.style.top=px(this.n.offsetHeight+this.w.offsetHeight);
		this.s.style.left=px(this.sw.offsetWidth);
		this.s.style.top=px(this.n.offsetHeight+this.c.offsetHeight);
		this.s.style.width=px(w-this.sw.offsetWidth-this.se.offsetWidth);
		this.se.style.top=px(this.ne.offsetHeight+this.w.offsetHeight);
		this.se.style.left=px(this.sw.offsetWidth+this.s.offsetWidth);
		this.mask.style.top=this.loading.style.top=px(this.n.offsetHeight);
		this.mask.style.height=this.loading.style.height=px(h-this.n.offsetHeight);
		//this.resizer.style.top=px(h-this.resizer.offsetHeight);
		//this.resizer.style.left=px(w-this.resizer.offsetWidth);

		//兼容AIR
		$(this.content).resize();
		if(this.layout)this.layout.resizeAll();
		try{this.content.$C.scroll();}catch(e){}
		$(window).resize();
		return true;
	}

	this.closeWin=function(){
		if(this.app.modal){
			if(!this.modal)return;
		}
		this.active();
		if(this.beforeclose){
			if(!this.beforeclose())return;
		}
		if(options.unclosed){			
			this.hideWin();
		}else{
			if(this.content.contentWindow)this.content.contentWindow.location='about:blank';
			$(this.WIN).remove();
		}
		if(this.menu){$(this.menu).remove();}
		
		if(this.modal){ 
		    if( (this.type==1&&this.container.childNodes.length<1)||(this.type==2&&this.container.childNodes.length<2) ){
				$(this.container).hide();
				this.app.unModal();
			}
		}
		
		this.app.topWin=null;
		this.container.topWin=null;
		window.curWin=null;
		if(this.preWin&&this.preWin!=this){
			this.preWin.nxtWin=null;
			if(!this.preWin.options.unclosed)this.preWin.active();
		}
		if(this.icon){
			var $icon=$(this.icon);
			window.setTimeout(function(){ $icon.remove();} , 200);
		}
		window[this]=null;
		if(options.onClose)options.onClose.apply();
	}
	this.hideWin=function(){
		if(this.app.modal&&!this.modal)return;
		if(this.options.unclosed)this.WIN.style.display="none"
		else this.WIN.style.visibility="hidden";
		$(this.loading).hide();
		window.curWin=null;
		this.app.topWin=null;
	}
	this.maxWin=function(){
		if(this.app.modal&&!this.modal)return;
		$(this.max).toggleClass('restore');
		if(this.orignalWidth&&this.orignalHeight){			
			this.WIN.style.width=px(this.orignalWidth);
			this.WIN.style.height=px(this.orignalHeight);
			this.WIN.style.left=px(this.orignalLeft);
			this.WIN.style.top=px(this.orignalTop);
			this.resize();
			this.orignalWidth=this.orignalHeight=this.orignalLeft=this.orignalTop=null;
		}
		else{
			this.orignalWidth=this.WIN.offsetWidth;
			this.orignalHeight=this.WIN.offsetHeight;
			this.orignalLeft=this.WIN.offsetLeft;
			this.orignalTop=this.WIN.offsetTop;
			this.WIN.style.width=px($("body").width());
			this.WIN.style.height=px($("body").height()-this.app.menubar.offsetHeight);
			this.WIN.style.left=this.WIN.style.top="0px";
			this.resize();
		}
	}
	this.minWin=function(){
		if(this.app.modal&&!this.modal)return;
		if(this.options.unclosed)this.WIN.style.display="none"
		else this.WIN.style.visibility="hidden";
		try{$('embed',this.content).css({visibility:'hidden'});this.content.contentWindow.$('embed').css({visibility:'hidden'});this.content.contentWindow.player.$('#media').css({visibility:'hidden'});}catch(e){}
		
	}

	this.register=function(){
		if(this.icon)return;
		if(this.app.modal&&!this.modal)return;
		var src=options.icon;
		if(!src){
			src=window.top.urlpath+"/Library/win.jpg";
		}else{
			src=(this.app.path)?this.app.path+'/icons/'+options.icon:window.top.urlpath+options.icon;
		}
		var icon=document.createElement('a');
		icon.className=this.app.id;
		icon.innerHTML='<div><img src="'+src+'"/></div><span>' +this.n.innerHTML+ '</span>';
		$("#windowsBody").append(icon);
		icon.win=this;
		this.icon=icon; 
		$(icon).bind("click",function(){
			//if($("#windowsBody a").length<1)
			$("#windows").hide();
			this.win.app.active();
			this.win.active();
			try{$('embed',this.content).css({visibility:'visible'});this.win.content.contentWindow.$('embed').css({visibility:'visible'});this.win.content.contentWindow.player.$('#media').css({visibility:'visible'});}catch(e){}
		});
		setLang({app:this.app.id.replace('App_',''),el:icon,path:this.app.path});
	}


	this.collapseWin=function (){
		
	}

	this.setTitle=function(t){
        	this.n.innerHTML=t;
        	this.title=t;
		window.setLang({app:this.app.options.id,el:this.n,path:this.app.path});
	}

	this.addToMenu=function(){ 
		if(this.type==0){
			var o=$("#"+this.app.id+"_winMenu");
			if(o.length>0){
				var a=document.createElement("A");
				a.win=this;
				a.innerHTML=this.title;
				a.onclick=function(){this.win.active();};
				var li=document.createElement("LI");
				li.appendChild(a);
				li.title=this.id;
				o.after(li);
				this.menu=li;
			}
		}

	}

	this.options=options;
	this.init();
}	