﻿(function($){
$.addLauncher = function(t,o){
	var g={
		init:function(){
			o = $.extend({
				direction: 'vertical' //'horizontal'
				,size:48
				,left:48
				,top:160
				,color:'#ffffff'
				,border:'#cccccc'
				,opacity:50	
				,snap:'none'
				,snapto:'right'
				,hide:'false'
				,imagemargin:2
				,imagepadding:2
				,padding:6
				,threshold:12
			},o);
			if($('> div',t).length===0){
				o.left=(o.left==='auto')?$('body').width()-o.size-o.imagemargin*2-o.imagepadding*2-o.padding*2-o.threshold:o.left;
				o.top=(o.top==='auto')?160:o.top;
				$(t).append('<div class="titlebar"><div class="arrow"></div><div class="dir"></div></div><div class="win"></div><div class="body"></div><div class="title"></div>');
				$(t).css({
					left:o.left-0
					,top:o.top-0
				});	
				g.create();
				g.bindEvent();
			}else{
				g.create();
			}
		}

		,create:function(){
			$('img',t).css({
				margin:o.imagemargin
				,padding:o.imagepadding
			}).appendTo($('.body',t));
			$(t).removeClass('vertical').removeClass('horizontal'); 
			if(o.snap===true||o.snap==='true'){
				switch(o.snapto){
					case 'top':
						o.direction='horizontal';
					break;
					case 'bottom':
						o.direction='horizontal';
					break;
					case 'left':
						o.direction='vertical';
					break;
					case 'right':
						o.direction='vertical';
					break;
				}
			}
			$(t).addClass(o.direction);
			$('.win',t).css({
				position:'absolute'
				,left:0
				,top:0
				,background:o.color
				,border:'1px solid '+o.border
				,opacity:o.opacity/100
				,filter:'alpha(opacity='+o.opacity+')'
				,width:'100%'
				,height:'100%'
			});
			g.build();
			t.preferences=o;
		}
		
		,build:function(s){
			if(!s)s=o.size;
			if(s>72)s=72;
			if(s<16)s=16;
			$('img',t).css({
				width:s+'px'
				,height:s+'px'
			}).show();
			o.size=s;
			s=$('img',t).width()+o.imagemargin*2+o.imagemargin*2+2;
			var l=$('img',t).length*s+o.padding;		
			$('.body',t).css({
				position:'absolute'
				,left:0
				,top:0
				,width:(o.direction==='vertical')?s:l
				,height:(o.direction==='vertical')?l:s
				,padding:o.padding
			});
			$(t).css({
				width:$('.body',t)[0].offsetWidth
				,height:$('.body',t)[0].offsetHeight
			});	
			if(o.hide===true||o.hide==='true'){
				$(t).hide();
			}else{
				$(t).show();
			}
			$(t).resizable('option','aspectRatio',$(t).width()/$(t).height());
		}
		
		,bindEvent:function(){
			//$('.body',t).click(g.launch);	
			$(window).resize(function(){
				var w=$(t).width();
				var h=$(t).height();
				var p=t.style.top.replace('px','')-0;
				var l=t.style.left.replace('px','')-0;
				if(l<0-w)l=0;
				if(l>$('body').width())l=$('body').width()-w;
				if(p+h<0)p=0;
				if(p>$('body').height())p=$('body').height()-h;
				if(o.snap===true||o.snap==='true'){
					switch(o.snapto){
						case 'top':
							$(t).css({
								top:0
								,left:($('body').width()-w)/2
							});	
						break;
						case 'bottom':
							$(t).css({
								top:$('body').height()-h
								,left:($('body').width()-w)/2
							});
						break;
						case 'left':
							$(t).css({
								top:($('body').height()-h)/2
								,left:0
							});	
						break;
						case 'right':
							$(t).css({
								top:($('body').height()-h)/2
								,left:$('body').width()-w
							});	
						break;
					}
				}else{
					$(t).css({
						left:l
						,top:p
					});	
				}
			}).resize();
			
			$(t)
			.draggable('destroy')
			.draggable({
				ios:true
				,iframeFix:true
				,start:function(event, ui){
					if($(event.originalEvent.target).hasClass('dockicon')){return false;}
				}
				,stop:function(event, ui){
					o.snap=false;
					if(event.clientX>$('body').width()-o.threshold){o.snap=true;o.snapto='right';}
					if(event.clientX<o.threshold){o.snap=true;o.snapto='left';}
					if(event.clientY<o.threshold){o.snap=true;o.snapto='top';}
					if(event.clientY>$('body').height()-o.threshold){o.snap=true;o.snapto='bottom';}
					if(o.snap===true||o.snap==='true'){
						if($('.arrow',t).hasClass('closed')){$('.arrow',t).click()};
						g.create();
						$(window).resize();
						$(t).resizable('option','aspectRatio',$(t).width()/$(t).height());
					}
					g.save();
				}	
			})
			.resizable('destroy')
			.resizable({
				aspectRatio: $(t).width()/$(t).height()
				,minHeight: 32
            			,minWidth: 32
				,handles: 'se'
				,start:function(event, ui ){
					$('img',t).hide();
				}
				,stop:function(event, ui ){
					var s=(o.direction==='vertical')?ui.size.width:ui.size.height;
					s=s-o.padding*2-o.imagemargin*2-2;	
					g.build(s);
					$(window).resize();
					g.save();
				}
			})
			.unbind('mousemove')
			.mousemove(function(event){
					var x=event.pageX-$(t).position().left;
					var y=event.pageY-$(t).position().top;
					if($(event.target).hasClass('dockicon') ){
						var s=event.target.Title;
						var title=$.l10n.__(s);
						if(!$('.title',t).attr('domain')&&!/^System_application_/.test(s)){
							$('.title',t)
							.attr('domain','l10n')
							.attr('msgid',s)
							.html(title);
						}else{
							$('.title',t).html(title.replace('System_application_',''));
						}
					
						$('.title',t).show();
						var tw=$('.title',t).width();
						var th=$('.title',t).height();
						var w=$(t).width();
						var h=$(t).height();
						var l=t.style.left.replace('px','')-0;
						var p=t.style.top.replace('px','')-0;
						var left,top;
						if(o.direction==='horizontal'){
							left=x-tw/2;
							top=-th-16;
							if(p<16)top=h+4;
						}
						if(o.direction==='vertical'){
							top=y-th/2;
							left=-tw-16;
							if(l<tw)left=w+4;
						}
						$('.title',t)
						.css({
							left:left+'px'
							,top:top+'px'
						});
					}
			})
			.unbind('mouseout')
			.mouseout(function(){
				$('.title',t).hide();
			});
			
			
			$('.dir',t).unbind('click').click(function(){
				if($('.arrow',t).hasClass('closed'))$('.arrow',t).click();
				$(t).removeClass(o.direction);
				if(o.direction==='vertical'){
					o.direction='horizontal';
				}else{
					o.direction='vertical';
				}
				$(t).addClass(o.direction); 
				$(window).resize();
				g.build();
				g.save();
			});
			
			$('.arrow',t).unbind('click').click(function(){
				$('>div',t).toggle();
				$('.arrow',t).toggleClass('closed');
				$('.title',t).hide();
				$('.titlebar',t).show();
				if(!$('.arrow',t).hasClass('closed'))g.build();
				else $(t).hasClass('vertical')?$(t).height(0):$(t).width(0)
			});
			$('.titlebar',t).unbind('dblclick').dblclick(function(){
				$('.arrow',t).click();
			});
			
		}
		
		,save:function(e){
			o.size=$('img',t)[0].style.width.replace('px','');
			o.left=t.style.left.replace('px','');
			o.top=t.style.top.replace('px','');;
			o.hide=$(t).is(':hidden');
			var xml='<?xml version="1.0" encoding="UTF-8"?><launcher><preferences>'
			+'<direction>'+o.direction+'</direction>'
			+'<size>'+o.size+'</size>'
			+'<left>'+o.left+'</left>'
			+'<top>'+o.top+'</top>'
			+'<color>'+o.color+'</color>'
			+'<border>'+o.border+'</border>'
			+'<opacity>'+o.opacity+'</opacity>'
			+'<snap>'+o.snap+'</snap>'
			+'<snapto>'+o.snapto+'</snapto>'
			+'<hide>'+o.hide+'</hide>'
			+'</preferences></launcher>';
			var options = {
					content: xml
					,content_type:  'text/xml'                   
			};
			window.top.webdav.PUT({}, window.top.root+'home/.launcher.conf', options);
		}
	};
	g.init();
	t.g=g;
	return g;
};

$.fn.launcher = function(o) {
	return this.each( function() {
		$.addLauncher(this,o);
	});

}; 
})(jQuery);