#!/bin/sh

file=/etc/hosts
interface=eth0

ip=`ifconfig $interface | grep "inet addr" | sed 's/^.*inet\ addr:\([0-9]*.[0-9]*.[0-9]*.[0-9]*\).*$/\1/'`
hostname=`hostname`

if [ -n "$hostname" ] ; then
	echo "hostname = $hostname"
	sed -i /$hostname/d $file
fi

if [ -n "$ip" ] ; then
	echo "ip = $ip"
	sed -i /$ip/d $file
	if [ `grep -c $ip $file` = 0 ] ; then
		echo $ip $hostname >> $file
	else
#		cat $file | sed s/^.*$ip.*$/$ip\ $hostname/ > /tmp/.fixed
		sed -i s/^.*$ip.*$/$ip\ $hostname/ $file
#		mv /tmp/.fixed $file
	fi

fi

echo "sed host-name"
sed -i  s/^#*host-name.*/host-name=$hostname/ /etc/avahi/avahi-daemon.conf 


file=/etc/sysconfig/network
#cat $file | sed s/^.*HOSTNAME.*$/HOSTNAME=$hostname/ > /tmp/.fixed
sed -i s/^HOSTNAME.*$/HOSTNAME=$hostname/  $file
#mv /tmp/.fixed $file

file=/etc/sysconfig/network-scripts/ifcfg-eth0
if [ `grep -c HOSTNAME $file` = 0 ] ; then
	echo "HOSTNAME=$hostname" >> $file
else
#	cat $file | sed s/^.*HOSTNAME.*$/HOSTNAME=$hostname/ > /tmp/.fixed
	sed -i s/^HOSTNAME.*$/HOSTNAME=$hostname/ $file
#	mv /tmp/.fixed $file
fi

file=/etc/dhcp/dhclient.conf
#cat $file | sed s/^.*host-name.*$/send\ host-name\ \"$hostname\"\;/ > /tmp/.fixed
sed -i s/^.*host-name.*$/send\ host-name\ \"$hostname\"\;/ $file
#mv /tmp/.fixed $file
sync


