#!/usr/bin/python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 03:38:08 PM CST

import sys
from nas.service import *
from nas.system import get_name_value
from nas.system import set_name_value
from nas.system import _canwrite
from nas import check_public
from ConfigParser import ConfigParser
AFPCONF = '/etc/netatalk/AppleVolumes.default'
SAMBACONF = '/etc/nas/smb.conf'
REALSAMBACONF = '/etc/samba/smb.conf'
USRMOUNTCONF = '/etc/samba/usrmount.conf'
USB1CONF = '/etc/samba/usb1.conf'
USB2CONF = '/etc/samba/usb2.conf'
USBCOPYCONF = '/etc/samba/usbcopy.conf'

def autoremove():
    dev = "/dev/%s" % sys.argv[1]
    os.system("umount -l %s" % dev)
    checkdir()
    with open('/etc/netatalk/AppleVolumes.default','r') as fd:
	while True:
            line = fd.readline()
            if not line:
                break
            if line.startswith("/media"):
                print line
                path = line.strip().split()[0]
                if not os.path.exists(path):
                    checksmbpath(path)
                    print "path = %s" % path
                    rmafpdev(path)
#    restartservice('smb', 'smbd', 139)
#    restartservice('netatalk', 'afpd', 548)
    
			
def checksmbpath(path, **kw):
    _checksmbpath(path, USRMOUNTCONF)
    _checksmbpath(path, USB1CONF)
    _checksmbpath(path, USB2CONF)
    _checksmbpath(path, USBCOPYCONF)
    restartsmb()
    
def _checksmbpath(path, confpath, **kw):
    print "================*********\n path = %s ************\n" % path
    cf = ConfigParser()
    cf.read(confpath)
    s = cf.sections()
    name = os.path.basename(path)
    for n in s:
        print "%s == %s" % (n, name)
        if n != name:
            continue
        else:
            path = cf.get(n,'path')
#            if not os.path.exists(path):
            cf.remove_section(n)
            cf.write(open(confpath, 'w'))	

def rmafpdev(path):
    pi = open('/etc/netatalk/AppleVolumes.default')
    lines = pi.readlines()
    open(AFPCONF,"w").write("")
    for x in lines:
        if path not in x:
            open(AFPCONF,'a').write(x)
    restartafpd()
	
def checkdir():
    found = False
    dirlist = ["/media/%s" % _dir for _dir in os.listdir('/media')]
    for _dir in dirlist:
#        os.system("chattr -i %s" % _dir)
#        dirlist.remove(_dir)
        with open("/proc/mounts", "r") as fd:
            while True:
                line = fd.readline()
                if not line:
                    break
                mountdir = line.split()[1]
                if mountdir == _dir:
                    found = True
                    break
        if found == False:
            try:
                os.system("chattr -i %s" % _dir)
                os.system("rm -rf %s" % _dir)
            except:
                pass

def restartsmb():
    smbstatus = servicestatus('smb')
    if smbstatus == 'yes' and _canwrite():
        restartservice('smb', 'smbd', 139)

def restartafpd():
    afpdstatus = servicestatus('netatalk')
    if afpdstatus == 'yes' and _canwrite():
        restartservice('netatalk', 'afpd', 548)

if __name__ == '__main__':
    autoremove()
