﻿window.urlpath=(window.location.protocol+"//"+window.location.host+window.location.pathname).replace("index.html","");//域名或ip地址
window.remoteDataUrl='/';//系统数据目录

$(function(){
	layout();	
	bindEvent();
	loadNASinfo();
	//loadsponsors();
});


function layout(){	
	$(window).resize(function(){
		var h=document.documentElement.offsetHeight;
		var l=document.getElementById("login");
		var b=document.getElementById("bottom");
		var lh=l.offsetHeight;
		l.style.top=px((h-lh)/2-50); 
		var t=l.offsetTop+l.offsetHeight;
		b.style.top=px(t);
	}).resize();
}

function  bindEvent(){
	document.getElementById('username').focus();
	if(getRequest('lang')&&getRequest('lang')!="")window.Lang=getRequest('lang').replace('_','-').toLowerCase();	
	

	
	var lastuser=getCookie('lastuser');
	var L=document.getElementById('lang')
	if(lastuser){
		$("#rememberme").attr('checked','checked');
		var userdata=$.parseJSON(lastuser);
		$("#username").val(userdata.name);
		var $L=$("#lang option:[value='"+userdata.language+"']");
		$L.attr("selected","selected");
		L.selectedIndex=$L.index();
		loadLang($("#lang").val());
	}
	else{
		loadLang();
		var $L=$("#lang option[value='"+window.Lang+"']");
		$L.attr("selected","selected");
		L.selectedIndex=$L.index();
	}

	
	//设置语言
	$("#lang").change(function(){
		setLang({app:window.App,lang:this.value});
		//loadsponsors();
	});	
	
	//添加登录按钮事件
	$("#OK").click(function(){ getNonceString();return false; });
	$("#username, #mangled_password").keypress(function(e){
		if(e.which==13)$("#OK").click();
	});

	//显示提示
	$('#forget')
		.mouseenter(function(e){$('#description').show().css({top:e.pageY, left:e.pageX});})
		.mouseleave(function(e){$('#description').hide();});
}


function loadsponsors(){
	$.ajax({
		url: 'Sponsors/'+window.Lang.toLowerCase()+'.xml'
		,type: "GET"
		,cache:false
		,dataType:"xml"
		,success: function(data){
				parsesponsors(data);
		}
		,error:function(data){
		}
	});
}

function parsesponsors(data){
	var sponsors=$('sponsor',data);
	if(sponsors.length>0){
		$('#sponsorlabel').show();
		$('#sponsors').empty();
		$('sponsor',data).each(function(){
			$('#sponsors').append('<a href="'+$('link',this).text()+'" title="'+$('name',this).text()+'" target="_blank" class="sponsor"><img src="Sponsors/logos/'+$('logo',this).text()+'"/></a>');
		});
	}
}


function loadNASinfo(){
	$.getScript(window.remoteDataUrl+'nas/get/register?output=json&callback=parseNASinfo&_='+new Date().getTime()); 
}


function parseNASinfo(json){
	$('#register').html(json.register);
	$('#hostname').html(json.hostname);
	$('#ipaddr').html(json.ipaddr);
	$('#upnpaddr').html(json.upnpaddr?json.upnpaddr.split(':')[1]:'no mapping');
	//$('#hwaddr').html(json.hwaddr);
	$('#fwversion').html(json.software);
}

//--------------------------------登录-------------------------------------------------------------
function login(hash,modulus,public){
	var pass=Crypt($("#mangled_password").val(),modulus,public);
	$.ajax({
		url: remoteDataUrl+"nas/login"
		,cache:false
		,data:{
			user:$("#username").val()
			,pass:pass
			,hash:hash
			,lang:window.Lang
		}
		,cache:false
		,type: "POST"
		,dataType:"xml"		
		,success: function(data){
			if(checkAPIError(data)){$("#waiting").hide();return;}
			var privilege = ($("#username").val()=='admin')?0:1;
			var ip = $("ipaddr:first",data).text();
			var SessionID = hash;
			if($("#username").val()=='admin')privilege='0';
			if($("#rememberme").attr('checked')) setLoginCookies();
			else delLoginCookies();
			//setCookie('session',SessionID); 
			//var platform=navigator.platform;
			//if(platform=="iPhone")
			window.open(window.urlpath+'Applications/System/os.html?lang='+$("#lang").val()+'&id='+SessionID+'&remoteDataUrl='+window.remoteDataUrl+"&user="+$("#username").val()+"&privilege="+privilege+'&modulus='+modulus+'&public='+public+'&','_self'); 
			
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
		
	});
}


//--------------------------------获取登录验证码------------------------------------------------
function getNonceString(){
	if(!validate())return;
	$("#waiting").show();
	$.ajax({
		url: remoteDataUrl+"nas/gen/hash"
		,data:{time:new Date()}
		,type: "POST"
		,cache:false
		,dataType:"xml"
		,success: function(data){ 
			//get nonce.			
			var hash=$(data).find("hash").text();
			var modulus=$(data).find("modulus").text();	
			var public=$(data).find("public").text();
			login(hash,modulus,public);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ($.l10n.__("global_alert_getdataerror"));
		}
		//,timeout:20000
	});
}




function validate(){
	var n=$("#username").val().replace(/\s/g,"");
	var p=$("#mangled_password").val().replace(/\s/g,"");
	if(n==""||p==""){
		alert( $.l10n.__("global_alert_inputerror"));
		return false;
	}
	return true;
}



function setLoginCookies(){
	var userdata={
		name: $('#username').val()
		,language: window.Lang
	};
	userdata=$.toJSON(userdata);
	setCookie('lastuser',userdata);
}


function delLoginCookies(){
	delCookie('lastuser');
}